﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZLPlugin_MR.Model;

namespace ZLPlugin_MR.Domain
{
    internal static class Infos
    {
        static UserInfo _userinfo = null;
        public static ADODB.Connection Con { get; set; }
        public static UserInfo UserInfo
        {
            get { if (_userinfo == null) GetUserinfo(); return _userinfo; }
        }
        public static ConfigModel Config { get; private set; }
        static void GetUserinfo()
        {
            var sql = @"
Select P.id,P.编号,P.简码,P.姓名,D.编码 部门编码,D.名称 部门名称,M.部门ID,u.用户名
From 上机人员表 u,人员表 P,部门表 D,部门人员 M
Where U.人员id=P.ID and P.id=M.人员id and M.缺省=1 And M.部门id=D.ID and U.用户名=user";
            try
            {
                var rsRecord = new ADODB.Recordset();
                rsRecord.Open(sql, Con);

                if (rsRecord.EOF || rsRecord.BOF)
                    return;
                _userinfo = new UserInfo
                {
                    ID = rsRecord.Fields["id"].Value,
                    编号 = rsRecord.Fields["编号"].Value,
                    姓名 = rsRecord.Fields["姓名"].Value,
                    部门id = rsRecord.Fields["部门ID"].Value,
                    部门 = rsRecord.Fields["部门名称"].Value,
                    简码 = rsRecord.Fields["简码"].Value,
                    用户名 = rsRecord.Fields["用户名"].Value,
                    部门编号 = rsRecord.Fields["部门编码"].Value
                };
                rsRecord.Close();
            }
            catch (Exception ex)
            {
                Domain.Units.Log.Info("基本信息初始化失败：" + ex.Message);
            }
        }

        public static void ReadConfig()
        {
            //return;
            //调整ConfigModel及SQL语句以进行实现
            //var comandText = "";
            //Config = Domain.Units.DbHelper.ExcuteSql<ConfigModel>(comandText, Con).FirstOrDefault();
        }
    }
}
