﻿using System;
using System.IO;
using System.Net;
using System.Text;

namespace ZLPlugin_MR.Domain.Units
{
    public class HttpUtils
    {
        public static string WSCenterData(string url, string data)
        {
            string srcString = string.Empty;
            try
            {
                Encoding myEncoding = Encoding.GetEncoding("UTF-8");
                ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3; //将提交的字符串数据转换成字节数组 //注意提交的编码,这里默认的是Default：系统当前编码
                byte[] postData = myEncoding.GetBytes(data); //设置提交的相关参数
                HttpWebRequest request = WebRequest.Create(url) as HttpWebRequest;
                request.Method = "POST";
                request.KeepAlive = false;
                request.ProtocolVersion = HttpVersion.Version10;
                ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls;
                //request.ContentType = "text/xml;charset=utf-8";
                request.ContentType = "application/json;charset=utf-8";
                request.Headers.Add("code", "ZHONGLIAN");

                request.ContentLength = postData.Length;

                using (System.IO.Stream writer = request.GetRequestStream())
                {
                    writer.Write(postData, 0, postData.Length);
                }

                HttpWebResponse response = request.GetResponse() as HttpWebResponse;
                using (System.IO.Stream sr = response.GetResponseStream())
                {
                    using (StreamReader reader = new StreamReader(sr, myEncoding))
                    {
                        srcString = reader.ReadToEnd();
                    }
                }
                //result = JSON.JsonToObject<Result>(Tools.FormatStr(srcString), Encoding.UTF8);
            }
            catch (Exception ex)
            {
                Log.Info("请求入参：" + data);
                Log.Info("请求出参：" + srcString);
                Log.Info(ex.Message);
            }
            return srcString;
        }

    }
}
